

{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (inaki@blueleaf.cc)

/No description available in the introspection data./
-}

#define ENABLE_OVERLOADING (MIN_VERSION_haskell_gi_overloading(1,0,0) \
       && !defined(__HADDOCK_VERSION__))

module GI.GstVideo.Structs.VideoChromaResample
    ( 

-- * Exported types
    VideoChromaResample(..)                 ,
    noVideoChromaResample                   ,


 -- * Methods
-- ** free #method:free#

#if ENABLE_OVERLOADING
    VideoChromaResampleFreeMethodInfo       ,
#endif
    videoChromaResampleFree                 ,


-- ** getInfo #method:getInfo#

#if ENABLE_OVERLOADING
    VideoChromaResampleGetInfoMethodInfo    ,
#endif
    videoChromaResampleGetInfo              ,




    ) where

import Data.GI.Base.ShortPrelude
import qualified Data.GI.Base.ShortPrelude as SP
import qualified Data.GI.Base.Overloading as O
import qualified Prelude as P

import qualified Data.GI.Base.Attributes as GI.Attributes
import qualified Data.GI.Base.ManagedPtr as B.ManagedPtr
import qualified Data.GI.Base.GClosure as B.GClosure
import qualified Data.GI.Base.GError as B.GError
import qualified Data.GI.Base.GVariant as B.GVariant
import qualified Data.GI.Base.GValue as B.GValue
import qualified Data.GI.Base.GParamSpec as B.GParamSpec
import qualified Data.GI.Base.CallStack as B.CallStack
import qualified Data.GI.Base.Properties as B.Properties
import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map
import qualified Foreign.Ptr as FP
import qualified GHC.OverloadedLabels as OL


-- | Memory-managed wrapper type.
newtype VideoChromaResample = VideoChromaResample (ManagedPtr VideoChromaResample)
-- XXX Wrapping a foreign struct/union with no known destructor or size, leak?
instance WrappedPtr VideoChromaResample where
    wrappedPtrCalloc = return nullPtr
    wrappedPtrCopy = return
    wrappedPtrFree = Nothing

-- | A convenience alias for `Nothing` :: `Maybe` `VideoChromaResample`.
noVideoChromaResample :: Maybe VideoChromaResample
noVideoChromaResample = Nothing


#if ENABLE_OVERLOADING
instance O.HasAttributeList VideoChromaResample
type instance O.AttributeList VideoChromaResample = VideoChromaResampleAttributeList
type VideoChromaResampleAttributeList = ('[ ] :: [(Symbol, *)])
#endif

-- method VideoChromaResample::free
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "resample", argType = TInterface (Name {namespace = "GstVideo", name = "VideoChromaResample"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #GstVideoChromaResample", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Nothing
-- throws : False
-- Skip return : False

foreign import ccall "gst_video_chroma_resample_free" gst_video_chroma_resample_free :: 
    Ptr VideoChromaResample ->              -- resample : TInterface (Name {namespace = "GstVideo", name = "VideoChromaResample"})
    IO ()

{- |
Free /@resample@/
-}
videoChromaResampleFree ::
    (B.CallStack.HasCallStack, MonadIO m) =>
    VideoChromaResample
    {- ^ /@resample@/: a 'GI.GstVideo.Structs.VideoChromaResample.VideoChromaResample' -}
    -> m ()
videoChromaResampleFree resample = liftIO $ do
    resample' <- unsafeManagedPtrGetPtr resample
    gst_video_chroma_resample_free resample'
    touchManagedPtr resample
    return ()

#if ENABLE_OVERLOADING
data VideoChromaResampleFreeMethodInfo
instance (signature ~ (m ()), MonadIO m) => O.MethodInfo VideoChromaResampleFreeMethodInfo VideoChromaResample signature where
    overloadedMethod _ = videoChromaResampleFree

#endif

-- method VideoChromaResample::get_info
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "resample", argType = TInterface (Name {namespace = "GstVideo", name = "VideoChromaResample"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #GstVideoChromaResample", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "n_lines", argType = TBasicType TUInt, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "the number of input lines", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "offset", argType = TBasicType TInt, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "the first line", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Nothing
-- throws : False
-- Skip return : False

foreign import ccall "gst_video_chroma_resample_get_info" gst_video_chroma_resample_get_info :: 
    Ptr VideoChromaResample ->              -- resample : TInterface (Name {namespace = "GstVideo", name = "VideoChromaResample"})
    Word32 ->                               -- n_lines : TBasicType TUInt
    Int32 ->                                -- offset : TBasicType TInt
    IO ()

{- |
The resampler must be fed /@nLines@/ at a time. The first line should be
at /@offset@/.
-}
videoChromaResampleGetInfo ::
    (B.CallStack.HasCallStack, MonadIO m) =>
    VideoChromaResample
    {- ^ /@resample@/: a 'GI.GstVideo.Structs.VideoChromaResample.VideoChromaResample' -}
    -> Word32
    {- ^ /@nLines@/: the number of input lines -}
    -> Int32
    {- ^ /@offset@/: the first line -}
    -> m ()
videoChromaResampleGetInfo resample nLines offset = liftIO $ do
    resample' <- unsafeManagedPtrGetPtr resample
    gst_video_chroma_resample_get_info resample' nLines offset
    touchManagedPtr resample
    return ()

#if ENABLE_OVERLOADING
data VideoChromaResampleGetInfoMethodInfo
instance (signature ~ (Word32 -> Int32 -> m ()), MonadIO m) => O.MethodInfo VideoChromaResampleGetInfoMethodInfo VideoChromaResample signature where
    overloadedMethod _ = videoChromaResampleGetInfo

#endif

#if ENABLE_OVERLOADING
type family ResolveVideoChromaResampleMethod (t :: Symbol) (o :: *) :: * where
    ResolveVideoChromaResampleMethod "free" o = VideoChromaResampleFreeMethodInfo
    ResolveVideoChromaResampleMethod "getInfo" o = VideoChromaResampleGetInfoMethodInfo
    ResolveVideoChromaResampleMethod l o = O.MethodResolutionFailed l o

instance (info ~ ResolveVideoChromaResampleMethod t VideoChromaResample, O.MethodInfo info VideoChromaResample p) => OL.IsLabel t (VideoChromaResample -> p) where
#if MIN_VERSION_base(4,10,0)
    fromLabel = O.overloadedMethod (O.MethodProxy :: O.MethodProxy info)
#else
    fromLabel _ = O.overloadedMethod (O.MethodProxy :: O.MethodProxy info)
#endif

#endif


