

{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (inaki@blueleaf.cc)

Extra data passed to a video transform 'GI.Gst.Callbacks.MetaTransformFunction' such as:
\"gst-video-scale\".
-}

#define ENABLE_OVERLOADING (MIN_VERSION_haskell_gi_overloading(1,0,0) \
       && !defined(__HADDOCK_VERSION__))

module GI.GstVideo.Structs.VideoMetaTransform
    ( 

-- * Exported types
    VideoMetaTransform(..)                  ,
    newZeroVideoMetaTransform               ,
    noVideoMetaTransform                    ,


 -- * Methods
-- ** scaleGetQuark #method:scaleGetQuark#

    videoMetaTransformScaleGetQuark         ,




 -- * Properties
-- ** inInfo #attr:inInfo#
{- | the input 'GI.GstVideo.Structs.VideoInfo.VideoInfo'
-}
    clearVideoMetaTransformInInfo           ,
    getVideoMetaTransformInInfo             ,
    setVideoMetaTransformInInfo             ,
#if ENABLE_OVERLOADING
    videoMetaTransform_inInfo               ,
#endif


-- ** outInfo #attr:outInfo#
{- | the output 'GI.GstVideo.Structs.VideoInfo.VideoInfo'
-}
    clearVideoMetaTransformOutInfo          ,
    getVideoMetaTransformOutInfo            ,
    setVideoMetaTransformOutInfo            ,
#if ENABLE_OVERLOADING
    videoMetaTransform_outInfo              ,
#endif




    ) where

import Data.GI.Base.ShortPrelude
import qualified Data.GI.Base.ShortPrelude as SP
import qualified Data.GI.Base.Overloading as O
import qualified Prelude as P

import qualified Data.GI.Base.Attributes as GI.Attributes
import qualified Data.GI.Base.ManagedPtr as B.ManagedPtr
import qualified Data.GI.Base.GClosure as B.GClosure
import qualified Data.GI.Base.GError as B.GError
import qualified Data.GI.Base.GVariant as B.GVariant
import qualified Data.GI.Base.GValue as B.GValue
import qualified Data.GI.Base.GParamSpec as B.GParamSpec
import qualified Data.GI.Base.CallStack as B.CallStack
import qualified Data.GI.Base.Properties as B.Properties
import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map
import qualified Foreign.Ptr as FP
import qualified GHC.OverloadedLabels as OL

import {-# SOURCE #-} qualified GI.GstVideo.Structs.VideoInfo as GstVideo.VideoInfo

-- | Memory-managed wrapper type.
newtype VideoMetaTransform = VideoMetaTransform (ManagedPtr VideoMetaTransform)
instance WrappedPtr VideoMetaTransform where
    wrappedPtrCalloc = callocBytes 16
    wrappedPtrCopy = \p -> withManagedPtr p (copyBytes 16 >=> wrapPtr VideoMetaTransform)
    wrappedPtrFree = Just ptr_to_g_free

-- | Construct a `VideoMetaTransform` struct initialized to zero.
newZeroVideoMetaTransform :: MonadIO m => m VideoMetaTransform
newZeroVideoMetaTransform = liftIO $ wrappedPtrCalloc >>= wrapPtr VideoMetaTransform

instance tag ~ 'AttrSet => Constructible VideoMetaTransform tag where
    new _ attrs = do
        o <- newZeroVideoMetaTransform
        GI.Attributes.set o attrs
        return o


-- | A convenience alias for `Nothing` :: `Maybe` `VideoMetaTransform`.
noVideoMetaTransform :: Maybe VideoMetaTransform
noVideoMetaTransform = Nothing

{- |
Get the value of the “@in_info@” field.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' videoMetaTransform #inInfo
@
-}
getVideoMetaTransformInInfo :: MonadIO m => VideoMetaTransform -> m (Maybe GstVideo.VideoInfo.VideoInfo)
getVideoMetaTransformInInfo s = liftIO $ withManagedPtr s $ \ptr -> do
    val <- peek (ptr `plusPtr` 0) :: IO (Ptr GstVideo.VideoInfo.VideoInfo)
    result <- SP.convertIfNonNull val $ \val' -> do
        val'' <- (newBoxed GstVideo.VideoInfo.VideoInfo) val'
        return val''
    return result

{- |
Set the value of the “@in_info@” field.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.set' videoMetaTransform [ #inInfo 'Data.GI.Base.Attributes.:=' value ]
@
-}
setVideoMetaTransformInInfo :: MonadIO m => VideoMetaTransform -> Ptr GstVideo.VideoInfo.VideoInfo -> m ()
setVideoMetaTransformInInfo s val = liftIO $ withManagedPtr s $ \ptr -> do
    poke (ptr `plusPtr` 0) (val :: Ptr GstVideo.VideoInfo.VideoInfo)

{- |
Set the value of the “@in_info@” field to `Nothing`.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.clear' #inInfo
@
-}
clearVideoMetaTransformInInfo :: MonadIO m => VideoMetaTransform -> m ()
clearVideoMetaTransformInInfo s = liftIO $ withManagedPtr s $ \ptr -> do
    poke (ptr `plusPtr` 0) (FP.nullPtr :: Ptr GstVideo.VideoInfo.VideoInfo)

#if ENABLE_OVERLOADING
data VideoMetaTransformInInfoFieldInfo
instance AttrInfo VideoMetaTransformInInfoFieldInfo where
    type AttrAllowedOps VideoMetaTransformInInfoFieldInfo = '[ 'AttrSet, 'AttrGet, 'AttrClear]
    type AttrSetTypeConstraint VideoMetaTransformInInfoFieldInfo = (~) (Ptr GstVideo.VideoInfo.VideoInfo)
    type AttrBaseTypeConstraint VideoMetaTransformInInfoFieldInfo = (~) VideoMetaTransform
    type AttrGetType VideoMetaTransformInInfoFieldInfo = Maybe GstVideo.VideoInfo.VideoInfo
    type AttrLabel VideoMetaTransformInInfoFieldInfo = "in_info"
    type AttrOrigin VideoMetaTransformInInfoFieldInfo = VideoMetaTransform
    attrGet _ = getVideoMetaTransformInInfo
    attrSet _ = setVideoMetaTransformInInfo
    attrConstruct = undefined
    attrClear _ = clearVideoMetaTransformInInfo

videoMetaTransform_inInfo :: AttrLabelProxy "inInfo"
videoMetaTransform_inInfo = AttrLabelProxy

#endif


{- |
Get the value of the “@out_info@” field.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' videoMetaTransform #outInfo
@
-}
getVideoMetaTransformOutInfo :: MonadIO m => VideoMetaTransform -> m (Maybe GstVideo.VideoInfo.VideoInfo)
getVideoMetaTransformOutInfo s = liftIO $ withManagedPtr s $ \ptr -> do
    val <- peek (ptr `plusPtr` 8) :: IO (Ptr GstVideo.VideoInfo.VideoInfo)
    result <- SP.convertIfNonNull val $ \val' -> do
        val'' <- (newBoxed GstVideo.VideoInfo.VideoInfo) val'
        return val''
    return result

{- |
Set the value of the “@out_info@” field.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.set' videoMetaTransform [ #outInfo 'Data.GI.Base.Attributes.:=' value ]
@
-}
setVideoMetaTransformOutInfo :: MonadIO m => VideoMetaTransform -> Ptr GstVideo.VideoInfo.VideoInfo -> m ()
setVideoMetaTransformOutInfo s val = liftIO $ withManagedPtr s $ \ptr -> do
    poke (ptr `plusPtr` 8) (val :: Ptr GstVideo.VideoInfo.VideoInfo)

{- |
Set the value of the “@out_info@” field to `Nothing`.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.clear' #outInfo
@
-}
clearVideoMetaTransformOutInfo :: MonadIO m => VideoMetaTransform -> m ()
clearVideoMetaTransformOutInfo s = liftIO $ withManagedPtr s $ \ptr -> do
    poke (ptr `plusPtr` 8) (FP.nullPtr :: Ptr GstVideo.VideoInfo.VideoInfo)

#if ENABLE_OVERLOADING
data VideoMetaTransformOutInfoFieldInfo
instance AttrInfo VideoMetaTransformOutInfoFieldInfo where
    type AttrAllowedOps VideoMetaTransformOutInfoFieldInfo = '[ 'AttrSet, 'AttrGet, 'AttrClear]
    type AttrSetTypeConstraint VideoMetaTransformOutInfoFieldInfo = (~) (Ptr GstVideo.VideoInfo.VideoInfo)
    type AttrBaseTypeConstraint VideoMetaTransformOutInfoFieldInfo = (~) VideoMetaTransform
    type AttrGetType VideoMetaTransformOutInfoFieldInfo = Maybe GstVideo.VideoInfo.VideoInfo
    type AttrLabel VideoMetaTransformOutInfoFieldInfo = "out_info"
    type AttrOrigin VideoMetaTransformOutInfoFieldInfo = VideoMetaTransform
    attrGet _ = getVideoMetaTransformOutInfo
    attrSet _ = setVideoMetaTransformOutInfo
    attrConstruct = undefined
    attrClear _ = clearVideoMetaTransformOutInfo

videoMetaTransform_outInfo :: AttrLabelProxy "outInfo"
videoMetaTransform_outInfo = AttrLabelProxy

#endif



#if ENABLE_OVERLOADING
instance O.HasAttributeList VideoMetaTransform
type instance O.AttributeList VideoMetaTransform = VideoMetaTransformAttributeList
type VideoMetaTransformAttributeList = ('[ '("inInfo", VideoMetaTransformInInfoFieldInfo), '("outInfo", VideoMetaTransformOutInfoFieldInfo)] :: [(Symbol, *)])
#endif

-- method VideoMetaTransform::scale_get_quark
-- method type : MemberFunction
-- Args : []
-- Lengths : []
-- returnType : Just (TBasicType TUInt32)
-- throws : False
-- Skip return : False

foreign import ccall "gst_video_meta_transform_scale_get_quark" gst_video_meta_transform_scale_get_quark :: 
    IO Word32

{- |
Get the @/GQuark/@ for the \"gst-video-scale\" metadata transform operation.
-}
videoMetaTransformScaleGetQuark ::
    (B.CallStack.HasCallStack, MonadIO m) =>
    m Word32
    {- ^ __Returns:__ a @/GQuark/@ -}
videoMetaTransformScaleGetQuark  = liftIO $ do
    result <- gst_video_meta_transform_scale_get_quark
    return result

#if ENABLE_OVERLOADING
#endif

#if ENABLE_OVERLOADING
type family ResolveVideoMetaTransformMethod (t :: Symbol) (o :: *) :: * where
    ResolveVideoMetaTransformMethod l o = O.MethodResolutionFailed l o

instance (info ~ ResolveVideoMetaTransformMethod t VideoMetaTransform, O.MethodInfo info VideoMetaTransform p) => OL.IsLabel t (VideoMetaTransform -> p) where
#if MIN_VERSION_base(4,10,0)
    fromLabel = O.overloadedMethod (O.MethodProxy :: O.MethodProxy info)
#else
    fromLabel _ = O.overloadedMethod (O.MethodProxy :: O.MethodProxy info)
#endif

#endif


